
# Test that slicing of arrays works as expected, and does not
# inadvertantly change the wrong string.
#
# a = [0,1,2,3,4]
# b = a[1:3]
# print_int_array(a)
# print_int_array(b)

STRING

newline:	"\n"

CODE

	icopy	newline, r10

	icopy	sp, r0
	ipush	0
	anew	[r0]		# a->[]
	ainsert	0, 0, [r0]
	ainsert	1, 1, [r0]
	ainsert	2, 2, [r0]
	ainsert	3, 3, [r0]
	ainsert	4, 4, [r0]	# a->[0,1,2,3,4]

	icopy	sp, r1
	ipush	0
	acopy	[r0], [r1]	# b = a
	aslice	1, 3, [r1]	# b = b[1:3]

	apush	[r0]
	call	function_print_int_array
	sprint	[r10]

	apush	[r1]
	call	function_print_int_array
	sprint	[r10]

	halt


# A set of functions for printing arrays.
# There are three functions:
#  print_int_array(a:array)
#  print_real_array(a:array)
#  print_string_array(a:array)
# We need three functions since there is no way within the Ace VM
# to check the type of a memory cell, except indirectly using
# the 'acmp' or 'asort' instructions, which is dodgy.

function_print_int_array:
	ipush	r0		# save
	ipush	r1		# save
	ipush	r2		# save
	ipush	r3		# save

	icopy	sp, r3
	ipush	0		# r3->blank spot

	iadd	fp, -3, r0	# a: the array to be printed
	icopy	0, r1		# r1=0 (conter)
	alen	[r0], r2	# r2=size(a) (end of loop)

function_print_int_array_loop_1:
	icmp	r1, r2
	bge	function_print_int_array_loop_1_end
	aindex	r1, [r0], [r3]
	iprint	[r3]
	iadd	1, r1
	bra	function_print_int_array_loop_1
function_print_int_array_loop_1_end:

	iadd	-1, sp, sp	# remove temporary

	ipop	r3		# restore
	ipop	r2		# restore
	ipop	r1		# restore
	ipop	r0		# restore

	ret

function_print_real_array:
	ipush	r0		# save
	ipush	r1		# save
	ipush	r2		# save
	ipush	r3		# save

	icopy	sp, r3
	ipush	0		# r3->blank spot

	iadd	fp, -3, r0	# a: the array to be printed
	icopy	0, r1		# r1=0 (conter)
	alen	[r0], r2	# r2=size(a) (end of loop)

function_print_real_array_loop_1:
	icmp	r1, r2
	bge	function_print_real_array_loop_1_end
	aindex	r1, [r0], [r3]
	dprint	[r3]
	iadd	1, r1
	bra	function_print_real_array_loop_1
function_print_real_array_loop_1_end:

	iadd	-1, sp, sp	# remove temporary

	ipop	r3		# restore
	ipop	r2		# restore
	ipop	r1		# restore
	ipop	r0		# restore

	ret

function_print_string_array:
	ipush	r0		# save
	ipush	r1		# save
	ipush	r2		# save
	ipush	r3		# save

	icopy	sp, r3
	ipush	0		# r3->blank spot

	iadd	fp, -3, r0	# a: the array to be printed
	icopy	0, r1		# r1=0 (conter)
	alen	[r0], r2	# r2=size(a) (end of loop)

function_print_string_array_loop_1:
	icmp	r1, r2
	bge	function_print_string_array_loop_1_end
	aindex	r1, [r0], [r3]
	sprint	[r3]
	iadd	1, r1
	bra	function_print_string_array_loop_1
function_print_string_array_loop_1_end:

	iadd	-1, sp, sp	# remove temporary

	ipop	r3		# restore
	ipop	r2		# restore
	ipop	r1		# restore
	ipop	r0		# restore

	ret

