
# Adding two arrays together
# This test tries some trickier things, like adding an array to itself,
# and storing the array into the same location as itself.
# Quite legal, but may result in memory faults in buggy VMs.

CODE

	icopy	0, r0
	icopy	1, r1
	icopy	2, r2
	icopy	3, r3

	anew	[r0]
	ainsert	0, 1, [r0]
	ainsert	1, 2, [r0]

	anew	[r1]
	ainsert	0, 3, [r1]
	ainsert	1, 4, [r1]
	ainsert	2, 5, [r1]

	aadd	[r0], [r0], [r2]	# src1 == src2
	aindex	0, [r2], [r3]
	iprint	[r3]
	aindex	1, [r2], [r3]
	iprint	[r3]
	aindex	2, [r2], [r3]
	iprint	[r3]
	aindex	3, [r2], [r3]
	iprint	[r3]

	aadd	[r0], [r1], [r1]	# src2 == dst
	aindex	0, [r1], [r3]
	iprint	[r3]
	aindex	1, [r1], [r3]
	iprint	[r3]
	aindex	2, [r1], [r3]
	iprint	[r3]
	aindex	3, [r1], [r3]
	iprint	[r3]
	aindex	4, [r1], [r3]
	iprint	[r3]

	aadd	[r0], [r0], [r0]	# src1 == src2 == dst
	aindex	0, [r0], [r3]
	iprint	[r3]
	aindex	1, [r0], [r3]
	iprint	[r3]
	aindex	2, [r0], [r3]
	iprint	[r3]
	aindex	3, [r0], [r3]
	iprint	[r3]

	halt

