
# Test if the array comparison functions work.
# Check that Integers,Doubles < Strings < Arrays
# We do this by checking that [6.9] < [7] < ["3"] < [[2]]

INT

int:	7
int2:	2

DOUBLE

dbl:	6.9

STRING

str:	"3"

CODE

	icopy	10, r0
	icopy	11, r1
	icopy	12, r2
	icopy	13, r3
	icopy	14, r4

	icopy	int, r7		# r7->7
	icopy	dbl, r8		# r8->6.9
	icopy	str, r9		# r9->"3"
	icopy	int2, r10	# r10->2

	anew	[r0]		# r0->[]
	ainsert	0, [r8], [r0]	# r0->[6.9]

	anew	[r1]		# r1->[]
	ainsert	0, [r7], [r1]	# r1->[7]

	anew	[r2]		# r2->[]
	ainsert	0, [r9], [r2]	# r2->["3"]

	anew	[r3]		# r3->[]
	anew	[r4]		# r4->[]
	ainsert	0, [r10], [r4]	# r4->[2]
	ainsert 0, [r4], [r3]	# r3->[[2]]

	acmp	[r0], [r1]	# r0 < r1 since [6.9] < [7]
	bgt	fail1		# just in case flags are set wrong
	beq	fail1		# just in case flags are set wrong
	blt	yes1
fail1:
	iprint	4		# wrong answer
	bra	test2
yes1:
	iprint	-1		# correct answer

test2:
	acmp	[r1], [r2]	# r1 < r2 since [7] < ["3"]
	beq	fail2		# should not happen
	bgt	fail2		# should not happen
	blt	yes2
fail2:
	iprint	6		# wrong answer
	bra	test3
yes2:
	iprint	-1		# correct answer

test3:
	acmp	[r2], [r3]	# r2 < r3 since ["3"] < [[2]]
	beq	fail3		# should not happen
	bgt	fail3		# should not happen
	blt	yes3
fail3:
	iprint	8		# wrong answer
	bra	end
yes3:
	iprint	-1		# correct answer

end:
	halt

