/*
 *  This program tests the speed of compiled C code doing integer
 *  operations, by repeatedly doing a number of operations in a
 *  loop. The number of iterations is controlled by an integer
 *  variable read in from stdin. Change this number to a million or
 *  more, if you want a good speed test.
 *  Compile this program using gcc, then use the unix 'time' command
 *  to see how long this code takes to run:
 *    time a.out < intspeed.in
 */

#include <stdio.h>

char *report = " was the result\n";

int main(int argc, char *argv[])
{
	long repeat;
	long r0, r1, r4;

	scanf("%ld", &repeat);
	r0 = repeat;
	r1 = 0;
	r4 = 7;

	while (r1 < r0) {
		r4 = r4 / 2;
		r4 *= 15;
		r4 += repeat;
		r4 %= 11;

		r0 --;
	}

	printf("%ld", r4);
	printf(report);
	return 0;
}
