#
#  A program to demonstrate recursive functions.
#  This program calculates and prints the factorial of
#  a number, e.g. 8! = 8 x 7 x 6 x 5 x 4 x 3 x 2 x 1
#  The program demonstrates how to perform function calls
#  in assembly language.
#  The frame pointer fp is used to find the parameters to
#  the function, and where the return value is to be
#  stored.
#

STRING

question: "Find the factorial of which number? "
str:	"\nThe factorial of "
is:	" is "
newline: "\n"

CODE

main:
	icopy	question, r2
	sprint	[r2]			# print question

	iread	r5			# read the number

	ipush	0			# make space for result
	ipush	r5			# push parameter (num) onto the stack
	call	factorial		# push pc, push fp, call the function
	ipop	r5			# pop parameter (num)
	ipop	r6			# pop result

	icopy	str, r2
	sprint	[r2]			# print "\nThe factorial of "
	iprint	r5			# print num
	icopy	is, r2
	sprint	[r2]			# print " is "
	iprint	r6			# print result
	icopy	newline, r2
	sprint	[r2]			# print "\n"
	halt

factorial:
	ipush	r10			# save some registers
	ipush	r11
	ipush	r12

					# Now:
					# [FP+2] == [SP-1] == r12
					# [FP+1] == [SP-2] == r11
					# [FP+0] == [SP-3] == r10
					# [FP-1] == [SP-4] == return pc
					# [FP-2] == [SP-5] == old fp
					# [FP-3] == [SP-6] == num
					# [FP-4] == [SP-7] == return value cell

	iadd	fp, -3, r10
	icopy	[r10], r10		# fetch parameter 1 (num)
	iadd	fp, -4, r12		# return value cell pointer

	icmp	r10, 1
	bgt	recurse			# if num > 1 goto recurse
	icopy	1, [r12]		# else return 1
	bra	end_factorial		# clean up and exit function

recurse:
	ipush	0			# make space for result
	iadd	r10, -1, r11
	ipush	r11			# push parameter 1 (num-1)
	call	factorial		# calculate factorial(num-1)
	ipop	r11			# pop parameter 1 (num-1) and discard
	ipop	r11			# pop the returned result
	imul	r10, r11, [r12]		# return i * factorial(num-1)

end_factorial:
					# clean up and return
	ipop	r12			# restore saved registers
	ipop	r11
	ipop	r10
	ret				# pop fp, pop pc, branch to pc+1

